;
; MINICHESS 850
; o
;
.include "minchess.h"

.area _CODE

;
; ҂
;
; 
; Ȃ
;
; o
; BC, BC',DE',HL':j
;
delay::
	ld B, #64
delay_loop:
	call peekkey
	djnz delay_loop
	ret

;
; |[Y
;
; 
; Ȃ
;
; o
; Ȃ
;
pause::
	push AF
pause_loop:
	call getkey
	cp #0x1e
	JR NZ, pause_loop
	pop AF
	ret

;
; L[͂𓾂
;
; 
; Ȃ
;
; o
; A:L[R[h
; F:j
;
getkey::
	push BC
	push DE
	push HL
	exx
	push BC
	push DE
	push HL
	call 0xbcfd
getkey_skip:
	cp #0x01 ; OFF
	jr Z, getkey_quit
	cp #0x19 ; BASIC
	jp Z, 0x0000
	cp #0x1a ; TEXT
	jr Z, getkey_quit
	cp #0x51 ; BREAK
	jr Z, getkey_quit
	pop HL
	pop DE
	pop BC
	exx
	pop HL
	pop DE
	pop BC
	ret

getkey_quit:
	xor A
	ld (#0x7965), A
	jp quit

;
; L[͂𓾂(͑҂Ȃ)
;
; 
; Ȃ
;
; o
; A:L[R[h
; F,BC',DE',HL':j
;
peekkey::
	push BC
	call 0xbe53
	pop BC
	ret

;
; ʒu\
;
; 
; A:Տ̈ʒu
; DE:\ʒu
;
; o
; DE:̕\ʒu
; AF:j
;
print_pos::
	push BC
	push HL

	ex DE, HL
	call to_xy
	ex DE, HL

	ld A, #"1" - 2
	add H

	push AF
	ld A, #"a" - 1
	add L
	call putchr
	pop AF
	call putchr

	pop HL
	pop BC
	ret

;
; \
;
; 
; DE:\ʒu
; HL:̐擪
;
; o
; DE:̕\ʒu
; HL:̕
;
print_str::
	push AF
	push BC

print_str_loop:
	ld A, (HL)
	inc HL
	or A
	jr Z, print_str_last
	call putchr
	jr print_str_loop

print_str_last:
	pop BC
	pop AF
	inc HL
	ret

;
; \
;
; 
; B:
; DE:\ʒu
; HL:̐擪
;
; o
; AF,BC,DE,HL:j
;
print_str_n::
	jp 0xbff1

;
; 󔒂\
;
; 
; A:󔒂̐
; DE:\ʒu
;
; o
; DE:̕\ʒu
; AF:j
;
print_spc::
	push AF
	push BC

	ld B, A
	ld A, #" "
	call 0xbfee
	inc E

	pop BC
	pop AF
	ret

.if 0
;
; t̐l(2)\
;
; 
; A:l
; DE:\ʒu
;
; o
; DE:̕\ʒu
; AF:j
;
print_num_s::
	bit 7, A
	jr NZ, print_num_s_neg
	push AF
	ld A, #"+"
	call putchr
	pop AF
	jr print_num

print_num_s_neg:
	neg
	push AF
	ld A, #"-"
	call putchr
	pop AF
.endif

;
; l(2)\
;
; 
; A:l
; DE:\ʒu
;
; o
; DE:̕\ʒu
; AF:j
;
print_num::
	push BC
	push HL

	ld B, #0
print_num_loop10:
	inc B
	sub #10
	jr NC, print_num_loop10
	dec B
	add #10

	push AF
	ld A, #"0"
	add B
	call putchr
	pop AF
	add #"0"
	call putchr

	pop HL
	pop BC
	ret

.if TEST_LEAVES
;
; l(5)\
;
; 
; DE:\ʒu
; HL:l
;
; o
; DE:̕\ʒu
; AF:j
;
print_num5::
	push BC
	push HL

	ld BC, #10000
	call print_num5_1
	ld BC, #1000
	call print_num5_1
	ld BC, #100
	call print_num5_1
	ld BC, #10
	call print_num5_1
	ld BC, #1
	call print_num5_1

	pop HL
	pop BC
	ret

print_num5_1:
	xor A
print_num5_loop:
	inc A
	or A
	sbc HL, BC
	jr NC, print_num5_loop
	dec A
	add HL, BC

	add #"0"
.endif

;
; 1\
;
; 
; A:
; DE:\ʒu
;
; o
; E:̈ʒu
;
putchr::
	push AF
	push BC
	push DE
	push HL

	; L?
	sub #0xa0
	jr C, putchr_skip
	cp #0x40
	jr C, putpat_skip
putchr_skip:
	add #0xa0

	; \
	call 0xbe5f

	pop HL
	pop DE
	pop BC
	pop AF
	inc E
	ret

;
; p^[\
;
; 
; A:p^[ԍ
; DE:\ʒu
;
; o
; E:̈ʒu
;
putpat::
	push AF
	push BC
	push DE
	push HL

putpat_skip:
	ld C, A
	add A
	add A
	add C
	add C
	ld C, A
	ld B, #0
	ld HL, #pattern
	add HL, BC

	ld B, #6
	call 0xbfd0

	pop HL
	pop DE
	pop BC
	pop AF
	inc E
	ret

;
; ʂ
;
; 
; Ȃ
;
; o
; AF,BC,DE,HL:j
;
cls::
	ld A, #0x40
	out (#0x40), A

	xor A
	ld (#0x790d), A

	ld A, #" "
	ld B, #24 * 6
	ld DE, #0x0000
	jp 0xbfee

;
; J[\\
;
; 
; DE:\ʒu
;
; o
; Ȃ
;
putcur::
	push AF
	push BC
	push DE
	push HL

	ld BC, #0x0641
	ld HL, #putcur_buf

	push BC
	push HL
	call setxy
	in A, (C)
	inir

	call setxy
	pop HL
	pop BC
	ld HL, #putcur_buf
putcur_loop:
	ld A, (HL)
	cpl
	out (C), A
	inc HL
	djnz putcur_loop

	pop HL
	pop DE
	pop BC
	pop AF
	ret

putcur_buf:
	.db 0, 0, 0, 0, 0, 0

;
; ɃXN[
;
; 
; Ȃ
;
; o
; AF,BC,DE,HL:j
;
scroll::
	ld DE, #0x0008
	call scroll_row
	call scroll_row
	call scroll_row
	call scroll_row
	call scroll_row
	ld A, #" "
	ld B, #13
	jp 0xbfee

scroll_row:
	push DE
	inc D
	ld BC, #0x4e41
	ld HL, #move_list
	call setxy
	in A, (C)
	push BC
	push HL
	inir
	pop HL
	pop BC
	pop DE

	call setxy
	otir

	inc D
	ret

;
; LCD/ǂݍ݈ʒuݒ肷 (putcur̉)
;
; 
; DE:\ʒu
;
; o
; AF:j
;
setxy:
	; ݉\ɂȂ܂ő҂
	in A, (#0x40)
	rlca
	jr C, setxy

	push DE

	; YWݒ肷
	ld A, #0xb0
	add D
	out (#0x40), A

	; XW6{ɂ
	ld A, E
	add A
	ld E, A
	add A
	add E
	ld E, A

	; XW()ݒ肷
	ld A, #0x0f
	and E
	out (#0x40), A

	; XW()ݒ肷
	ld A, E
	rrca
	rrca
	rrca
	rrca
	and #0x0f
	or #0x10
	out (#0x40), A

	pop DE
	ret

code_last::

;
; Copyright 2017 maruhiro
; All rights reserved. 
;
; Redistribution and use in source and binary forms, 
; with or without modification, are permitted provided that 
; the following conditions are met: 
;
;  1. Redistributions of source code must retain the above copyright notice, 
;     this list of conditions and the following disclaimer. 
;
;  2. Redistributions in binary form must reproduce the above copyright notice, 
;     this list of conditions and the following disclaimer in the documentation 
;     and/or other materials provided with the distribution. 
;
; THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, 
; INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND 
; FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL 
; THE REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
; SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
; PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; 
; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
; WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR 
; OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF 
; ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
;

; eof
