;
; MINICHESS 850
; C
;
.include "minchess.h"

.area _CODE

;
; C[`
;
; 
; Ȃ
;
; o
; AF,BC,DE,HL,IX,IY,AF',BC',DE',HL':j
;
main::
	ld (#reg_sp), SP

	; ĊJ?
	ld HL, (#history_p)
	ld A, H
	or L
	jr NZ, main_resume

	; C[v
main_loop:
	call cls
	call menu
main_resume:
	call match
	jr main_loop

quit::
	; I
	ld SP, (#reg_sp)
	ret

;
; j[
;
; 
; Ȃ
;
; o
; AF,BC,DE,HL,IX,IY,AF',BC',DE',HL':j
;
menu_set:
	ld (HL), C
	jr menu

menu_set_game:
	ld (HL), C
	xor A

menu_redo:
	push AF
	call cls
	pop AF

menu_loop:
	; 肷
	cp #KEY_OK
	ret Z

	; Q[I
	ld HL, #menu_game
	ld C, #0
	cp #KEY_GARDNER
	jr Z, menu_set_game
	inc C
	cp #KEY_PETTY
	jr Z, menu_set_game
	inc C
	cp #KEY_LOS_ALAMOS
	jr Z, menu_set_game

	; xI
	ld HL, #menu_lv
	ld C, #0
	cp #KEY_LV0
	jr Z, menu_set
	inc C
	cp #KEY_LV1
	jr Z, menu_set
	inc C
	cp #KEY_LV2
	jr Z, menu_set
	inc C
	cp #KEY_LV3
	jr Z, menu_set
	inc C
	cp #KEY_LV4
	jr Z, menu_set

	; EI
	ld HL, #menu_player
	ld C, #0
	cp #KEY_WHITE
	jr Z, menu_set
	inc C
	cp #KEY_BLACK
	jr Z, menu_set
	inc C
	cp #KEY_RND
	jr Z, menu_set
	inc C
	cp #KEY_DEMO
	jr Z, menu_set

menu::
	; 肪_\
	ld A, (#menu_player)
	ld HL, #msg_rnd
	cp #2
	jr Z, menu_player_rnd
	ld HL, #msg_none
menu_player_rnd:
	ld DE, #0x0012
	call print_str

	; nf𓾂
	ld E, #0
	ld A, (#menu_handi)
	or A
	jr Z, menu_lv_handi_skip
	dec A
	cp #4
	jr C, menu_lv_handi_b
menu_lv_handi_w:
	sub #4
	inc A
	inc A
	or #PLAYER_WHITE
	ld E, A
	jr menu_lv_handi_skip
menu_lv_handi_b:
	inc A
	inc A
	or #PLAYER_BLACK
	ld E, A
menu_lv_handi_skip:

	; Ex𓾂
	ld HL, #menu_lv
	ld C, (HL)
	inc C
	ld B, C
	ld A, (#menu_player)
	cp #3
	jr Z, menu_player_skip
	ld B, #0
	rrca
	call C, ex_player
	jr menu_player_skip
menu_player_skip:

	; Q[𓾂
	push BC
	ld A, (#menu_game)
	add A
	ld C, A
	ld B, #0
	ld HL, #game_list
	add HL, BC
	ld A, (HL)
	inc HL
	ld H, (HL)
	ld L, A

	; Q[\
	push HL
	push DE
	ld B, #16
	ld DE, #0x0208
	call print_str_n
	pop DE
	pop HL

	pop BC

	; IԂ\
	push BC
	push DE
	push HL
	call init_game
	call disp_game
	pop HL
	pop DE
	pop BC

	; f?
	ld A, (#menu_player)
	sub #3
	jr Z, menu_demo

	; _ɂ邩?
	inc A
	jr NZ, menu_not_rand

	; _ɂ
	call rand
	rlca
	jr NC, menu_not_rand
	call ex_player
	call init_game
menu_not_rand:

.if TEST_AUTO
	; eXg
	ld A, #KEY_DEMO
	jp menu_loop
.endif

	; ڂI
	ld DE, #0x0508
	push DE
	ld A, #16
	call print_spc
	pop DE
	ld HL, #msg_menu
	call print_str
	ld B, #4
	ld A, (#menu_item)
	or A
	jr Z, memu_sel_game
	dec A
	jr Z, menu_sel_level
	dec A
	jr Z, menu_sel_player

; nfI
menu_sel_handi:
	ld HL, #msg_handi
	call print_str
	ld C, #9
	ld HL, #menu_handi
menu_sel_item:
	ld DE, #menu_item
	call select_item
	jp menu_loop

; EI
menu_sel_player:
	ld HL, #msg_player
	call print_str
	ld C, #3
	ld HL, #menu_player
	jr menu_sel_item

; xI
menu_sel_level:
	ld HL, #msg_level
	call print_str
	ld C, #5
	ld HL, #menu_lv
	jr menu_sel_item

; Q[I
memu_sel_game:
	ld HL, #msg_game
	call print_str
	ld C, #3
	ld HL, #menu_game
	ld DE, #menu_item
	call select_item
	jp menu_redo

; fJn
menu_demo:
	ld A, #2
	ld (#menu_player), A
	ret

; ւ
ex_player:
	ld A, B
	ld B, C
	ld C, A
	ld A, #MASK_PLAYER
	xor E
	ld E, A
	ret

; bZ[W
msg_lv::
	.ascii /Lv\0/
msg_menu:
	.db #0x1d
	.db #0x1c
	.ascii /Item /
	.db #0x1e
	.db #0x1f
	.ascii /\0/
msg_game:
	.ascii /Game\0/
msg_player:
	.ascii /Player\0/
msg_level:
	.ascii /Level\0/
msg_handi:
	.ascii /Handi\0/
msg_rnd:
	.db #0x1e
	.db #0x1f
	.ascii /\0/
msg_none:
	.ascii /  \0/

;
; Q[
;
; 
; B:̃x
; C:̃x
; E:Ƃ(nf)
; HL:Q[
;
; o
; AF,AF',BC,DE,HL:j
;
init_game::
	; nfݒ肷
	ld A, E
	and #MASK_PIECE
	ld A, E
	jr NZ, init_game_handi
	xor A
init_game_handi:
	ld (#handi), A

	push BC
	push DE
	push HL

	; 萔
	ld HL, #0
	ld (#turn), HL

	; 
	ld (#history_p), HL

	; Ղ
	xor A
	ld BC, #PITCH * 6
	ld HL, #board0
	call memset

	; 
	ld C, #PITCH * 8
	ld HL, #ctrl_w
	call memset
	inc H
	call memset

	; 
	call rand
	ld (#rnd), A

	pop HL

	; Ղ̑傫Rs[
	ld BC, #16
	add HL, BC
	ld BC, #4
	ld DE, #width
	ldir

	pop BC

	; ǂRs[
	ld B, #PITCH * 6
	ld DE, #board0

	push BC
	push DE
	push HL
init_game_loop1:
	ld A, (HL)
	cp #WALL
	jr NZ, init_game_skip1
	ld (DE), A
init_game_skip1:
	inc HL
	inc DE
	djnz init_game_loop1
	pop HL
	pop DE
	pop BC

	; u
init_game_loop2:
	ld A, (HL)
	or A
	jr Z, init_game_not_put
	cp #WALL
	jr Z, init_game_not_put
	cp C
	jr NZ, init_game_put
	ld C, #0
	jr init_game_not_put

init_game_put:
	push BC
	push DE
	push HL
	call put_piece
	pop HL
	pop DE
	pop BC

init_game_not_put:
	inc HL
	inc DE
	djnz init_game_loop2

	pop BC

	; xݒ肷
	ld DE, #w_lv
	call set_lv
	ld B, C
	inc D

;
; vC[̃xݒ肷 (init_gamẻ)
;
; 
; B:x
; DE:ݒ
; HL:xꗗ̐擪
;
; o
; AF:j
;
set_lv:
	push BC
	push DE
	push HL

	ld A, B
	ld (DE), A
	inc DE
	or A
	jr Z, set_lv_man

set_lv_loop:
	push DE
	ld BC, #7
	ldir
	pop DE
	dec A
	jr NZ, set_lv_loop

set_lv_last:
	pop HL
	pop DE
	pop BC
	ret

set_lv_man:
	ld (DE), A
	inc E
	dec A
	ld (DE), A

	ld E, #POS_KING
	ld A, (DE)
	ld (#curpos), A
	jr set_lv_last

;
; 1Ǒΐ킷
;
; 
; Ȃ
;
; o
; AF,BC,DE,HL,IX,IY,AF',BC',DE',HL':j
;
match::
	; \
	call cls
	call disp_game

	; ߂炩?
	ld HL, (#history_p)
	ld A, H
	or L
	jr Z, match_init

	; 𕜋A
	ld IX, (#history_p)

	; ̍ĊJ?
	ld HL, #w_lv
	inc (HL)
	dec (HL)
	jr Z, match_white

	; ̍ĊJ?
	inc H
	inc (HL)
	dec (HL)
	jr Z, match_black

match_init:
	; 
	ld HL, #history
	ld (#history_p), HL
	ld IX, (#history_p)

match_loop:
	; 50胋[ɂ?
	call check_50move
	jr Z, match_end_50move

match_white:
.if 1
	; 
	ld A, (#w_depth)
	ld C, A
	ld A, #PLAYER_WHITE
	call think
	jr C, match_end_w

.if TEST
	; ̕]l\(eXg)
	push DE
	ld A, D
	ld DE, #0x0412
	call print_num_s
	pop DE

	ld A, E
	ld DE, #0x0415
	call print_num_s
.endif

	; w
	call play
	call msgpos
	call print_move_w
	call scroll
	call next_history
	call disp_game

.if TEST_LEAVES
	; t̐\(eXg)
	ld HL, (#leaves)
	ld DE, #0x0013
	call print_num5
.endif

	; ?
	call check_rep
	jr C, match_end_rep
	call check_draw
	jr C, match_end_draw

	; f~?
	call check_end_demo
	ret C
.endif

match_black:
.if 1
	; 
	ld A, (#b_depth)
	ld C, A
	ld A, #PLAYER_BLACK
	call think
	jr C, match_end_b

.if TEST
	; ̕]l\(eXg)
	push DE
	ld A, D
	ld DE, #0x0112
	call print_num_s
	pop DE

	ld A, E
	ld DE, #0x0115
	call print_num_s
.endif

	; w
	call play
	call msgpos
	call print_move_b
	call scroll
	call next_history
	call disp_game

.if TEST_LEAVES
	; t̐\(eXg)
	ld HL, (#leaves)
	ld DE, #0x0013
	call print_num5
.endif

	; ?
	call check_rep
	jr C, match_end_rep
	call check_draw
	jr C, match_end_draw

	; f~?
	call check_end_demo
	ret C
.endif
	jr match_loop

; Q[I 50胋[
match_end_50move:
	ld HL, #msg_50move
	jr match_end

; Q[I ǖʔ
match_end_rep:
	ld HL, #msg_rep
	jr match_end

; Q[I s
match_end_draw:
	ld HL, #msg_draw
	jr match_end

; Q[I Cgꂽ
match_end_w:
	ld HL, #msg_bwin
	call match_mate
	jr match_end

; Q[I Cgꂽ
match_end_b:
	ld HL, #msg_wwin
	call match_mate

; ʂ\
match_end:
	call msgpos
	call print_str
	ld HL, #0
	ld (#history_p), HL
.if TEST_AUTO
.else
	call pause
.endif
	jp delay

; `FbNCgȂ#\
match_mate:
	push AF
	push AF
	call msgpos
	dec D
	pop AF
	call print_mate
	inc D
	pop AF
	ret NZ
	ld HL, #msg_stalemate
	ret

; bZ[W
msg_stalemate:
	.db 0xa0 + CHR_HALF
	.ascii / - /
	.db 0xa0 + CHR_HALF
	.ascii /(Stalemate)\0/
msg_50move:
	.db 0xa0 + CHR_HALF
	.ascii /-/
	.db 0xa0 + CHR_HALF
	.ascii /(50move rule)\0/
msg_rep:
	.db 0xa0 + CHR_HALF
	.ascii /-/
	.db 0xa0 + CHR_HALF
	.ascii /(Repetition)\0/
msg_draw:
	.db 0xa0 + CHR_HALF
	.ascii / - /
	.db 0xa0 + CHR_HALF
	.ascii /\0/
msg_wwin:
	.ascii /1 - 0\0/
msg_bwin:
	.ascii /0 - 1\0/

;
; f𒆒f邩?
;
; 
; Ȃ
;
; o
; Cy:f, NC:fȂ
; HL:j
;
check_end_demo:
	; fłȂȂ߂
	or A
	ld HL, #w_lv
	inc (HL)
	dec (HL)
	ret Z
	inc H
	inc (HL)
	dec (HL)
	ret Z

	; L[ĂȂȂ߂
	call peekkey
	or A
	ret Z

check_end_demo_loop:
	call peekkey
	or A
	jr NZ, check_end_demo_loop

	; f~
	scf
	ret

;
; i߂, ܂̓Zbg (match̉)
;
; 
; IX:
;
; o
; IX:
; AF,BC,HL:j
;
next_history:
	; 萔i߂
	ld HL, #turn
	ld C, (HL)
	inc L
	ld B, (HL)
	inc BC
	ld (HL), B
	dec L
	ld (HL), C

	; , ܂͏i?
	ld A, OFF_CAP(IX)
	add OFF_PRO(IX)
	or A
	jr NZ, next_history_reset

	; |[𓮂?
	ld L, OFF_POS_TO(IX)
	ld H, #BOARD_H
	ld A, (HL)
	and #MASK_PIECE
	cp #PIECE_PAWN
	jr Z, next_history_reset

	; i߂
	ld BC, #4
	add IX, BC
	jr next_history_last

next_history_reset:
	; Zbg
	ld IX, #history
next_history_last:
	ld (#history_p), IX
	ret

;
; 50胋[ɂ? (match̉)
;
; 
; IX:
;
; o
; Z:, NZ:łȂ
; A,BC,HL:j
;
check_50move:
	push IX
	pop HL
	ld BC, #history
	or A
	sbc HL, BC
	ld BC, #-4 * 100
	add HL, BC

	inc H
	dec H
	ret NZ
	dec L
	inc L
	ret Z
	dec L
	dec L
	dec L
	dec L
	ret

;
; sɂ? (match̉)
;
; 
; Ȃ
;
; o
; Cy:, NC:łȂ
; A,HL:j
;
check_draw:
	; NB[, [N, |[0łȂΈł͂Ȃ
	ld HL, #count_wqueen
	ld A, (HL) ; NB[()̐
	inc L
	add (HL) ; [N()̐
	inc L
	inc L
	inc L
	add (HL) ; |[()̐
	inc H
	add (HL) ; |[()̐
	dec L
	dec L
	dec L
	add (HL) ; [N()̐
	dec L
	add (HL) ; NB[()̐
	or A
	ret NZ

	; iCg, rVbv1ȉȂΈ
	ld HL, #count_wbishop
	ld A, (HL) ; rVbv()̐
	inc L
	add (HL) ; iCg()̐
	inc H
	add (HL) ; iCg()̐
	dec L
	add (HL) ; rVbv()̐
	scf
	ret Z
	dec A
	scf
	ret Z
	or A
	ret

;
; ǖʔɂ? (match̉)
;
; 
; IX:
;
; o
; Cy:, NC:łȂ
; A,BC,DE,HL,AF':j
;
check_rep:
	; Ȃ?
	ld A, -4(IX)
	or A
	ret Z

	; Ղ̏Ԃޔ
	ld BC, #PITCH * 6
	ld DE, #board_cur
	ld HL, #board0
	ldir

	; 
	ld OFF_POS_FROM(IX), #0
	ld IY, #0

check_rep_loop1:
	; Ղ߂
	ld BC, #-4
	add IX, BC
	call undo

	; Ղv邩?
	ld BC, #PITCH * 6
	ld DE, #board_cur
	ld HL, #board0
	call memcmp
	jr NZ, check_rep_skip

	; v
	inc IY
check_rep_skip:

	; ŏ܂Ŗ߂?
	ld A, -4(IX)
	or A
	jr NZ, check_rep_loop1

check_rep_loop2:
	; Ղi߂
	call play
	ld BC, #4
	add IX, BC

	; Ō܂Ŗ߂?
	ld A, OFF_POS_FROM(IX)
	or A
	jr NZ, check_rep_loop2

	; ߋ2ȏ㓯Ֆʂ?
	push IY
	pop HL
	ld A, #1
	cp L
	ret

;
; Cg? (match̉)
;
; 
; A:
; IX:
;
; o
; Cy:Cg, NC:CgłȂ
; Z:XeCCg, NZ:`FbNCg
; A,BC,DE,HL,IY,AF',BC',DE',HL':j
;
check_end::
	ld C, #1

;
; 𓾂
;
; 
; A:
; C:[
; IX:
;
; o
; Cy:Q[I, NC:Q[IłȂ
; Z:XeCCg, NZ:`FbNCg
; A,BC,DE,HL,IY,AF',BC',DE',HL':j
;
think::
	; vC[?
	inc C
	dec C
	jp Z, input_move

.if TEST_LEAVES
	; t̐
	ld HL, #0
	ld (#leaves), HL
.endif

	push IX
	push AF

	; io[1ڐ̎萔𓾂
	call ins_start
	call make_move_list
	ld HL, #tick
	ld (HL), #0
	jr Z, think_tick_skip
	ld D, A
think_tick_loop:
	inc (HL)
	add D
	jr NC, think_tick_loop
think_tick_skip:
	inc L
	ld (HL), #0

	; abl̏lݒ肷
	push IX
	pop IY
	ld OFF_ALPHA_L(IY), #-MAX_EVAL
	ld OFF_ALPHA_H(IY), #-MAX_EVAL
	ld OFF_BETA_L(IY), #MAX_EVAL
	ld OFF_BETA_H(IY), #MAX_EVAL

	; ̈ꗗ݈̏ʒu
	ld DE, #-10
	add IY, DE

	; 
	call ins_start
	pop AF
	inc C
	rlca
	jr C, think_black

think_white:
	; ̎
	push BC
	ld BC, #7
	ld DE, #lv
	ld HL, #w_depth
	ldir
	pop BC

	call think_w
	ld A, OFF_POS_FROM(IX)
	or A
	call Z, is_checked_w
	jr think_last

think_black:
	; ̎
	push BC
	ld BC, #7
	ld DE, #lv
	ld HL, #b_depth
	ldir
	pop BC

	call think_b
	ld A, OFF_POS_FROM(IX)
	or A
	call Z, is_checked_b

think_last:
	pop IX
	ret

;
; vC[̎̓͂𓾂 (think̉)
;
; 
; A:
; IX:
;
; o
; Cy:Q[I, NC:Q[IłȂ
; Z:XeCCg, NZ:`FbNCg
; A,BC,DE,HL,IY,AF',BC',DE',HL':j
;
input_move:
	; Cg?
	ld (#input_move_player), A
	call check_end
	ret C
input_move_redo:
	ld A, (#input_move_player)

	; \Ȏ̈ꗗ𓾂
	push AF
	call ins_start
	call make_move_list

	; 萔\
	call msgpos
	pop AF
	call print_turn

	; I
	ld A, #12
	call input_pos_piece
	jr NC, input_move_redo
	or A
	jp Z, input_move_resign
	ld OFF_POS_FROM(IX), A

	; 󔒂?
	ld H, #BOARD_H
	ld L, A
	ld A, (HL)
	or A
	jr Z, input_move_can

	; ̋?
	ld HL, #input_move_player
	xor (HL)
	rlca
	jr C, input_move_can

	; s̕\
	ld A, #5
	push AF
	push DE
	call print_spc
	pop DE
	ld A, #"-"
	call putchr
	pop AF

	; sI
	call input_pos
	jr NC, input_move_can
	or A
	jp Z, input_move_resign
	ld OFF_POS_TO(IX), A

	; ł̍s? ()
	push AF
	ld HL, #rank_pro
	sub (HL)
	cp #PITCH
	jr C, input_move_pro_w
	pop AF

	; ł̍s? ()
	sub #POS_A1
	cp #PITCH
	jr C, input_move_pro_b

input_move_no_pro:
	; iȂ
	ld OFF_PRO(IX), #0

input_move_play:
	; ꗗɂ肩?
	ld OFF_CAP(IX), #0
	call find_move
	jp NC, input_move_can

	; 𓮂ƂɃLOɑ̗邩?
	; Ԃ𓾂 (NC:̎, Cy:̎)
	call play
	ld H, #BOARD_H
	ld L, OFF_POS_TO(IX)
	ld A, (HL)
	rlca
	; ̃LÖʒu̗̔𓾂
	inc H
	ld A, (#pos_bking)
	ld L, A
	jr C, input_move_skip
	; ̃LÖʒu̗̍𓾂
	inc H
	ld A, (#pos_wking)
	ld L, A
input_move_skip:
	; 邩?
	ld A, (HL)
	inc (HL)
	dec (HL)
	push AF
	call undo
	pop AF
	jp NZ, input_move_can

	; ߂
	or A
	ld DE, #0x0000
	ret

input_move_can:
	; ̕\Ă蒼
	call msgpos
	ld A, #12
	call print_spc
	jp input_move_redo

input_move_pro_w:
	pop AF

	; |[()?
	ld D, #BOARD_H
	ld E, OFF_POS_FROM(IX)
	ld A, (DE)
	cp #PIECE_WPAWN
	jr NZ, input_move_no_pro

	; i𓾂
	ld A, #PLAYER_WHITE
	call input_piece
	jp NC, input_move_can

	; i
	ld OFF_PRO(IX), A
	jr input_move_play

input_move_pro_b:
	; |[()?
	ld D, #BOARD_H
	ld E, OFF_POS_FROM(IX)
	ld A, (DE)
	cp #PIECE_BPAWN
	jr NZ, input_move_no_pro

	; i𓾂
	ld A, #PLAYER_BLACK
	call input_piece
	jp NC, input_move_can

	; i
	ld OFF_PRO(IX), A
	jr input_move_play

input_move_resign:
	; 邩?
	ld HL, #msg_resign
	call input_yn
	jp NC, input_move_redo

	; 
	xor A
	ld (#pos_check), A
	inc A
	scf
	ret

.if TEST
input_move_undo:
	; 邩?
	ld A, -4(IX)
	or A
	jp Z, input_move_redo
	ld A, -8(IX)
	or A
	jp Z, input_move_redo

	; ߂
	ld BC, #-4
	add IX, BC
	push BC
	call undo
	pop BC
	add IX, BC
	call undo
	call disp_game
	jp input_move
.endif

input_move_player:
	.ds 1

.area _HEADER(ABS)

; Ղ̏
.org BOARD_H * 0x100
board::
	.db #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL
	.db #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL
board0::
	.ds PITCH
board1::
	.ds PITCH
board2::
	.ds PITCH
board3::
	.ds PITCH
board4::
	.ds PITCH
board5::
	.ds PITCH
	.db #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL
	.db #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL
; Ղ̕
width::
	.ds 1
; Ղ̍
height::
	.ds 1
; 1ŏiłs
rank_pre::
	.ds 1
; iłs
rank_pro::
	.ds 1

; vl̃vC[̐[
lv::
	.ds 1
; vl̃vC[̎̌̍ő吔(O}p)
pruning::
	.ds 6

; io[1ڐ̎萔
tick::
	.ds 1
; i(255 = 100%)
progress::
	.ds 1

; 
rnd::
	.ds 1

; 萔
turn::
	.ds 2

; J[\ʒu
curpos::
	.ds 1

; Q[JnɎ菜(nf)
handi::
	.ds #1

; vOs̃X^bN|C^̒l
reg_sp::
	.ds #2
; ݈̏ʒu
history_p::
	.dw #0

; j[̑I
menu_item:
	.db #0
; j[őIQ[
menu_game::
	.db #1
; j[őIE
menu_player:
	.db #2
; j[őIx
menu_lv:
	.db #1
; j[őInf
menu_handi:
	.db #0

;
; ̈ꗗ猟 (input_movẻ)
;
; 
; IX:
;
; o
; Cy:݂, NC:Ȃ
; AF,BC,DE,HL:j
;
find_move:
	exx
	push BC
	push HL
	exx
	pop HL
	pop BC

	dec HL
	dec HL
	dec HL
	dec HL

find_move_loop:
	; 肪Ȃ?
	ld A, B
	or C
	ret Z

	dec BC
	dec BC
	dec BC
	dec BC

	; ړ𓾂
	dec HL
	dec HL
	ld D, (HL)
	dec HL
	ld E, (HL)
	dec HL

	; ړ悪v邩?
	ld A, D
	cp OFF_POS_TO(IX)
	jr NZ, find_move_loop
	ld A, E
	cp OFF_POS_FROM(IX)
	jr NZ, find_move_loop

	scf
	ret

;
; ̈ꗗ𐶐
;
; 
; A:
; BC',DE',HL':ꗗ̏
;
; o
; B:̐
; BC',DE',HL':ꗗ̏
; AF,AF',DE,HL:j
;
make_move_list::
	rlca
	jp C, make_move_list_b
	jp make_move_list_w

;
; }
;
; 
; A:Dx(0:`255:)
; B:i
; DE:ړ
; HL:ړ
; BC':̈ꗗ̃f[^
; DE':̈ꗗ̎񏑂݈ʒu
; HL':̈ꗗ̏ݍς݈ʒu
;
; o
; BC':̈ꗗ̃f[^
; DE':̈ꗗ̎񏑂݈ʒu
; HL':̈ꗗ̏ݍς݈ʒu
; AF:j
;
ins::
	push HL
	exx
	inc BC
	inc BC
	inc BC
	inc BC
	push BC
	push DE

	; }ʒu𓾂
ins_loop:
	cp (HL)
	jp C, ins_skip
	jp Z, ins_skip
	ldd
	ldd
	ldd
	ldd
	jp PE, ins_loop
ins_skip:

	; }
	push DE
	exx
	ld D, L
	pop HL
	ld (HL), A
	dec HL
	ld (HL), B
	dec HL
	ld (HL), D
	dec HL
	ld (HL), E
	exx

	; ̈ʒuֈړ
	pop DE
	ld L, E
	ld H, D
	inc DE
	inc DE
	inc DE
	inc DE
	pop BC
	exx
	pop HL
	ld D, H
	ret

;
; ̈ꗗ
;
; 
; Ȃ
;
; o
; BC',DE',HL':ꗗ̏
; F:j
;
ins_start::
	exx

	; 擪
	ld HL, #move_list

	; f[^
	ld BC, #0

	; ݍς݈ʒu
	inc HL
	inc HL
	inc HL
	ld (HL), B

	; 񏑂݈ʒu
	ld E, L
	ld D, H
	inc DE
	inc DE
	inc DE
	inc DE

	exx
	ret

;
; ɒl
;
; 
; A:l
; BC:
; HL:AhX
;
; o
; AF:j
;
memset::
	push BC
	push DE
	push HL

	ld D, H
	ld E, L
	ld (HL), A
	inc DE

	dec BC
	ldir

	pop HL
	pop DE
	pop BC
	ret

;
; r
;
; 
; BC:TCY
; DE:AhX
; HL:AhX
;
; o
; Z:v, NZ:sv
; A:j
;
memcmp::
	push BC
	push DE
	push HL

memcmp_loop:
	ld A, (DE)
	inc DE
	cpi
	jp NZ, memcmp_last
	ld A, B
	or C
	jp NZ, memcmp_loop

memcmp_last:
	pop HL
	pop DE
	pop BC
	ret

board_last::

.org CTRL_W_H * 0x100

; ()̏
ctrl_w::
w_eval_l::	; ()̐
	.ds 1
w_eval_h::	; ()̓_
	.ds 1
pos_wking::	; LO()̈ʒu
	.ds 1
count_wqueen::	; NB[()̐
	.ds 1
count_wrook::	; [N()̐
	.ds 1
count_wbishop::	; rVbv()̐
	.ds 1
count_wknight::	; iCg()̐
	.ds 1
count_wpawn::	; |[()̐
	.ds 1
w_lv::	; ̃x(\p)
	.ds 1
w_depth::	; ̐[
	.ds 1
w_pruning::	; ̎̌̍ő吔(O}p)
	.ds 6
	.ds PITCH * 6

;
; 1w
;
; 
; IX:
;
; o
; AF,AF',BC,DE,HL:j
;
play::
	; ړɋ邩?
	ld D, #BOARD_H
	ld E, OFF_POS_TO(IX)
	ld A, (DE)
.if 1
	cp #WALL
	jr Z, play_err1
.endif
	or A
	ld OFF_CAP(IX), A

	; ړ̋
	call NZ, remove_piece

	; i邩?
	ld E, OFF_POS_FROM(IX)
	ld A, OFF_PRO(IX)
	or A
	jp NZ, play_pro

	; ړ
	ld A, (DE)
.if 0
	cp #WALL
	jr Z, play_err2
.endif
	ex AF, AF'
play_skip:
	call remove_piece
	ex AF, AF'
	ld E, OFF_POS_TO(IX)

	; ړɋu
	jp put_piece

play_pro:
	; i
	ex AF, AF'
	jp play_skip

.if 1
play_err1::
	rst 0x30
	jp 0
play_err2::
	rst 0x30
.endif

;
; 1߂
;
; 
; IX:
;
; o
; AF,AF',BC,DE,HL:j
;
undo::
	; i?
	ld D, #BOARD_H
	ld E, OFF_POS_TO(IX)
	ld A, OFF_PRO(IX)
	or A
	jp NZ, undo_pro

	; ߂
	ld A, (DE)
.if 0
	cp #0x80
	jr Z, undo_err1
	cp #WALL
	jr Z, undo_err1
.endif
undo_skip:
	ex AF, AF'
	call remove_piece
	ex AF, AF'
	ld E, OFF_POS_FROM(IX)
	call put_piece

	; 邩?
	ld A, OFF_CAP(IX)
	or A
	ret Z

	; ߂
	ld E, OFF_POS_TO(IX)
	jp put_piece

undo_pro:
	; i߂
	and #MASK_PLAYER
	or #PIECE_PAWN
	jp undo_skip

.if 0
undo_err1::
	rst 0x30
	ret
.endif

;
; 1wȂ
;
; 
; IX:
;
; o
; AF,AF',BC,DE,HL:j
;
replay::
	; i?
	ld D, #BOARD_H
	ld E, -4 + OFF_POS_TO(IX)
	ld A, -4 + OFF_PRO(IX)
	or A
	jp NZ, replay_undo_pro

	; 菜
	ld A, (DE)
replay_skip1:
	push AF
	call remove_piece

	; 邩?
	ld A, -4 + OFF_CAP(IX)
	or A
	jp Z, replay_skip2

	; ߂
	ld E, -4 + OFF_POS_TO(IX)
	call put_piece
replay_skip2:

	; ړɋ邩?
	ld E, OFF_POS_TO(IX)
	ld A, (DE)
	or A
	ld OFF_CAP(IX), A

	; ړ̋
	call NZ, remove_piece

	; i邩?
	ld E, OFF_POS_TO(IX)
	ld A, OFF_PRO(IX)
	or A
	jp NZ, replay_pro

	; u
	pop AF
	jp put_piece

replay_pro:
	; i
	pop HL ; vbVꂽAWX^j
	jp put_piece

replay_undo_pro:
	; i߂
	and #MASK_PLAYER
	or #PIECE_PAWN
	jp replay_skip1

;
; iՏ̃AhX𓾂
;
; 
; DE:i
;
; o
; A:Տ̈ʒu
; F:j
;
to_board::
	ld A, D
	or A
	rlca
	rlca
	rlca
	add E
	ret

;
; Տ̃AhXi𓾂
;
; 
; A:Տ̈ʒu
;
; o
; DE:i
; AF:j
;
to_xy::
	ld E, A

	; D = A / 8
	rrca
	rrca
	rrca
	and #0x07
	ld D, A

	; E = A mod 8
	ld A, E
	and #0x07
	ld E, A
	ret

ctrl_w_last::

.org CTRL_B_H * 0x100

; ()̏
ctrl_b::
b_eval_l::	; ()̐
	.ds 1
b_eval_h::	; ()̓_
	.ds 1
pos_bking::	; LO()̈ʒu
	.ds 1
count_bqueen::	; NB[()̐
	.ds 1
count_brook::	; [N()̐
	.ds 1
count_bbishop::	; rVbv()̐
	.ds 1
count_bknight::	; iCg()̐
	.ds 1
count_bpawn::	; |[()̐
	.ds 1
b_lv::	; ̃x(\p)
	.ds 1
b_depth::	; ̐[
	.ds 1
b_pruning::	; ̎̌̍ő吔(O}p)
	.ds 6
	.ds PITCH * 6

; bZ[W
msg_thinking::
	.ascii /Thinking...\0/
msg_resign::
	.ascii /Resign? \0/
msg_yn::
	.ascii /N\/Y\0/

; p^[
pattern::
pat_none::
	.db 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
pat_none2::
	.db 0x55, 0x2a, 0x55, 0x2a, 0x55, 0x00
pat_wking::
	.db 0x70, 0x4a, 0x4f, 0x4a, 0x70, 0x00
pat_wqueen::
	.db 0x0e, 0x70, 0x4f, 0x70, 0x0e, 0x00
pat_wrook::
	.db 0x43, 0x7e, 0x43, 0x7e, 0x43, 0x00
pat_wbishop::
	.db 0x40, 0x5e, 0x71, 0x5e, 0x40, 0x00
pat_wknight::
	.db 0x44, 0x66, 0x5b, 0x66, 0x58, 0x00
pat_wpawn::
	.db 0x40, 0x60, 0x5a, 0x60, 0x40, 0x00
pat_bking::
	.db 0x70, 0x7a, 0x7f, 0x7a, 0x70, 0x00
pat_bqueen::
	.db 0x0e, 0x70, 0x7f, 0x70, 0x0e, 0x00
pat_brook::
	.db 0x43, 0x7e, 0x7f, 0x7e, 0x43, 0x00
pat_bbishop::
	.db 0x40, 0x5e, 0x7f, 0x5e, 0x40, 0x00
pat_bknight::
	.db 0x44, 0x66, 0x7f, 0x7e, 0x58, 0x00
pat_bpawn::
	.db 0x40, 0x60, 0x7a, 0x60, 0x40, 0x00
pat_left_0::
	.db 0x00, 0x00, 0x00, 0x00, 0x01, 0x01
pat_left_1::
	.db 0x24, 0x3e, 0x20, 0x00, 0xff, 0x00
pat_left_2::
	.db 0x32, 0x2a, 0x26, 0x00, 0xff, 0x00
pat_left_3::
	.db 0x2a, 0x2a, 0x14, 0x00, 0xff, 0x00
pat_left_4::
	.db 0x0e, 0x08, 0x3e, 0x00, 0xff, 0x00
pat_left_5::
	.db 0x2e, 0x2a, 0x12, 0x00, 0xff, 0x00
pat_left_6::
	.db 0x1c, 0x2a, 0x10, 0x00, 0xff, 0x00
pat_right_0::
	.db 0x01, 0x00, 0x00, 0x00, 0x00, 0x00
pat_right_1::
	.db 0xff, 0x00, 0x24, 0x3e, 0x20, 0x00
pat_right_2::
	.db 0xff, 0x00, 0x32, 0x2a, 0x26, 0x00
pat_right_3::
	.db 0xff, 0x00, 0x2a, 0x2a, 0x14, 0x00
pat_right_4::
	.db 0xff, 0x00, 0x0e, 0x08, 0x3e, 0x00
pat_right_5::
	.db 0xff, 0x00, 0x2e, 0x2a, 0x12, 0x00
pat_right_6::
	.db 0xff, 0x00, 0x1c, 0x2a, 0x10, 0x00
pat_a::
	.db 0x01, 0x61, 0x51, 0x71, 0x01, 0x01
pat_b::
	.db 0x01, 0x7d, 0x51, 0x21, 0x01, 0x01
pat_c::
	.db 0x01, 0x21, 0x51, 0x51, 0x01, 0x01
pat_d::
	.db 0x01, 0x21, 0x51, 0x7d, 0x01, 0x01
pat_e::
	.db 0x01, 0x31, 0x59, 0x59, 0x01, 0x01
pat_f::
	.db 0x01, 0x11, 0x79, 0x15, 0x01, 0x01
pat_half::
	.db 0x2f, 0x10, 0x08, 0x6c, 0x5a, 0x00

; Ղ̏(Gardner)
game_gardner::
	.ascii /Gardner         /
	.db #5, #5, #POS_A4, #POS_A5
	.db #WALL, #PIECE_WROOK, #PIECE_WKNIGHT, #PIECE_WBISHOP, #PIECE_WQUEEN, #PIECE_WKING, #WALL, #WALL
	.db #WALL, #PIECE_WPAWN, #PIECE_WPAWN, #PIECE_WPAWN, #PIECE_WPAWN, #PIECE_WPAWN, #WALL, #WALL
	.db #WALL, 0, 0, 0, 0, 0, #WALL, #WALL
	.db #WALL, #PIECE_BPAWN, #PIECE_BPAWN, #PIECE_BPAWN, #PIECE_BPAWN, #PIECE_BPAWN, #WALL, #WALL
	.db #WALL, #PIECE_BROOK, #PIECE_BKNIGHT, #PIECE_BBISHOP, #PIECE_BQUEEN, #PIECE_BKING, #WALL, #WALL
	.db #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL, #WALL
	.db 2, 5, 255, 255, 255, 255, 255
	.db 2, 255, 255, 255, 255, 255, 255
	.db 4, 16, 4, 255, 255, 255, 255
	.db 4, 255, 255, 255, 255, 255, 255
	.db 6, 4, 8, 14, 17, 255, 255

; Ղ̏(Petty chess)
game_petty::
	.ascii /Petty chess     /
	.db #5, #6, #POS_A5, #POS_A6
	.db #WALL, #PIECE_WQUEEN, #PIECE_WKING, #PIECE_WBISHOP, #PIECE_WKNIGHT, #PIECE_WROOK, #WALL, #WALL
	.db #WALL, #PIECE_WPAWN, #PIECE_WPAWN, #PIECE_WPAWN, #PIECE_WPAWN, #PIECE_WPAWN, #WALL, #WALL
	.db #WALL, 0, 0, 0, 0, 0, #WALL, #WALL
	.db #WALL, 0, 0, 0, 0, 0, #WALL, #WALL
	.db #WALL, #PIECE_BPAWN, #PIECE_BPAWN, #PIECE_BPAWN, #PIECE_BPAWN, #PIECE_BPAWN, #WALL, #WALL
	.db #WALL, #PIECE_BQUEEN, #PIECE_BKING, #PIECE_BBISHOP, #PIECE_BKNIGHT, #PIECE_BROOK, #WALL, #WALL
	.db 2, 5, 255, 255, 255, 255, 255
	.db 2, 255, 255, 255, 255, 255, 255
	.db 4, 16, 4, 255, 255, 255, 255
	.db 4, 255, 255, 255, 255, 255, 255
	.db 6, 4, 8, 14, 17, 255, 255

; Ղ̏(Los Alamos chess)
game_los_alamos::
	.ascii /Los Alamos chess/
	.db #6, #6, #POS_A5, #POS_A6
	.db #WALL, #PIECE_WROOK, #PIECE_WKNIGHT, #PIECE_WQUEEN, #PIECE_WKING, #PIECE_WKNIGHT, #PIECE_WROOK, #WALL
	.db #WALL, #PIECE_WPAWN, #PIECE_WPAWN, #PIECE_WPAWN, #PIECE_WPAWN, #PIECE_WPAWN, #PIECE_WPAWN, #WALL
	.db #WALL, 0, 0, 0, 0, 0, 0, #WALL
	.db #WALL, 0, 0, 0, 0, 0, 0, #WALL
	.db #WALL, #PIECE_BPAWN, #PIECE_BPAWN, #PIECE_BPAWN, #PIECE_BPAWN, #PIECE_BPAWN, #PIECE_BPAWN, #WALL
	.db #WALL, #PIECE_BROOK, #PIECE_BKNIGHT, #PIECE_BQUEEN, #PIECE_BKING, #PIECE_BKNIGHT, #PIECE_BROOK, #WALL
	.db 2, 6, 255, 255, 255, 255, 255
	.db 2, 255, 255, 255, 255, 255, 255
	.db 4, 16, 4, 255, 255, 255, 255
	.db 4, 255, 255, 255, 255, 255, 255
	.db 6, 4, 8, 15, 18, 255, 255

; Q[ꗗ
game_list::
	.dw #game_gardner
	.dw #game_petty
	.dw #game_los_alamos

; Ղ̈ꎞۑ̈
board_cur:
	.ds PITCH * 6

.if TEST_LEAVES
; t̐(eXgp)
leaves::
	.ds 2
.endif

; 
	.db 0, 0
	.db 0, 0, 0, 0
	.db 0, 0, 0, 0
history::
	.ds 4 * 100
	.ds 10 * 6

; ̈ꗗ
move_list::
	.ds 4 * 256

data_last::

;
; Copyright 2017 maruhiro
; All rights reserved. 
;
; Redistribution and use in source and binary forms, 
; with or without modification, are permitted provided that 
; the following conditions are met: 
;
;  1. Redistributions of source code must retain the above copyright notice, 
;     this list of conditions and the following disclaimer. 
;
;  2. Redistributions in binary form must reproduce the above copyright notice, 
;     this list of conditions and the following disclaimer in the documentation 
;     and/or other materials provided with the distribution. 
;
; THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, 
; INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND 
; FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL 
; THE REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
; SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
; PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; 
; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
; WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR 
; OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF 
; ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
;

; eof
