;
; MINICHESS 850
; }}VC^[tF[X
;
.include "minchess.h"

.area _CODE

;
; vC[̈ʒu̓͂𓾂 (ƈʒu\)
;
; 
; DE:\ʒu
;
; o
; A:ʒu
; Cy:͂, NC:͂Ȃ(LZ)
; BC,DE,HL:j
;
input_pos_piece::
	ld HL, #input_pos_params + 3
	ld (HL), #1
	jr input_pos_skip

;
; vC[̈ʒu̓͂𓾂 (ʒu\)
;
; 
; DE:\ʒu
;
; o
; A:ʒu
; Cy:͂, NC:͂Ȃ(LZ)
; BC,DE,HL:j
;
input_pos::
	ld HL, #input_pos_params + 3
	ld (HL), #0

input_pos_skip:
	; p[^ۑ
	dec HL
	ld (HL), A
	dec HL
	ld (HL), D
	dec HL
	ld (HL), E

input_pos_loop:
	; łȂ΃J[\ʒuƋ\
	call input_pos_print

	; J[\\, L[͂𓾂
	ld A, (#curpos)
	push DE
	call to_scr
	call putcur
	call getkey
	call putcur
	pop DE

input_pos_redo:
	; LZ
	cp #KEY_RESIGN
	jp Z, input_pos_resign
	cp #KEY_CAN
	jp Z, input_pos_can

	; ȂΕ\
	push AF
	ld HL, #input_pos_params + 2
	ld A, (HL)
	or A
	ld (HL), #0
	call NZ, print_spc
	pop AF

	; J[\𓮂
	ld C, #DIR_NW
	cp #KEY_UP_LEFT
	jr Z, input_pos_move
	inc C
	cp #KEY_UP
	jr Z, input_pos_move
	inc C
	cp #KEY_UP_RIGHT
	jr Z, input_pos_move

	ld C, #DIR_W
	cp #KEY_LEFT
	jr Z, input_pos_move
	inc C
	inc C
	cp #KEY_RIGHT
	jr Z, input_pos_move

	ld C, #DIR_SW
	cp #KEY_DOWN_LEFT
	jr Z, input_pos_move
	inc C
	cp #KEY_DOWN
	jr Z, input_pos_move
	inc C
	cp #KEY_DOWN_RIGHT
	jr Z, input_pos_move

	; I
	ld C, #1
	cp #KEY_A
	jr Z, input_pos_a
	cp #KEY_B
	jr Z, input_pos_b
	cp #KEY_C
	jr Z, input_pos_c
	cp #KEY_D
	jr Z, input_pos_d
	cp #KEY_E
	jr Z, input_pos_e
	cp #KEY_F
	jr Z, input_pos_f

	; ̑I
	cp #KEY_OK
	jr Z, input_pos_sel

.if 0
	; AhD(eXg)
	cp #0x08 ; U
	jr Z, input_pos_undo
.endif
	jr input_pos_loop

; J[\𓮂
input_pos_move:
	ld A, (#b_depth)
	or A
	jr NZ, input_pos_move_w
	ld A, C
	neg
	ld C, A
input_pos_move_w:

	ld DE, #curpos
	ld A, (DE)
	add C
	ld L, A
	ld H, #BOARD_H

	ld A, (HL)
	cp #WALL
	jp Z, input_pos_loop

	ld A, (DE)
	add C
	ld (DE), A
	jp input_pos_loop

; I
input_pos_f:
	inc C
input_pos_e:
	inc C
input_pos_d:
	inc C
input_pos_c:
	inc C
input_pos_b:
	inc C
input_pos_a:
input_pos_file:
	; ݒ肷
	ld HL, #curpos
	ld A, (HL)
	and #0xf8
	or C
	ld (HL), A

	; s𓾂
	push HL
	call input_pos_print
	dec E
	call putcur
	call getkey
	call putcur
	pop HL
	ld B, #2
	cp #KEY_1
	jr Z, input_pos_1
	cp #KEY_2
	jr Z, input_pos_2
	cp #KEY_3
	jr Z, input_pos_3
	cp #KEY_4
	jr Z, input_pos_4
	cp #KEY_5
	jr Z, input_pos_5
	cp #KEY_6
	jr Z, input_pos_6
	jp input_pos_redo
input_pos_6:
	inc B
input_pos_5:
	inc B
input_pos_4:
	inc B
input_pos_3:
	inc B
input_pos_2:
	inc B
input_pos_1:
input_pos_rank:
	ld A, B
	rlca
	rlca
	rlca
	or C
	ld (HL), A

; ʒu߂
input_pos_sel:
	call input_pos_print
	ld A, (#curpos)
	scf
	ret

; ߂
input_pos_resign:
	xor A
	scf
	ret

; LZ߂
input_pos_can:
	xor A
	ret

.if 0
; AhD߂
input_pos_undo:
	xor A
	scf
	ret
.endif

; ƈʒu\
input_pos_print:
	ld HL, #input_pos_params
	ld E, (HL)
	inc HL
	ld D, (HL)
	inc HL
	ld A, (HL)
	or A
	ret NZ
	inc HL
	ld A, (HL)
	rrca
	ld A, (#curpos)
	jp NC, print_pos

;
; ƈʒu\
;
; 
; A:ʒu
; DE:\ʒu
;
; o
; AF,HL:j
; DE:̈ʒu
;
print_piece_pos::
	push AF
	ld H, #BOARD_H
	ld L, A
	ld A, (HL)
	call get_symbol
	call putpat
	pop AF
	jp print_pos

; p[^̕ۑ̈
input_pos_params:
	.ds 4

;
; \
;
; 
; DE:\ʒu
; IX:
;
; o
; AF,HL:j
; DE:̈ʒu
;
print_move_w::
	call is_checked_b
	ld L, #PLAYER_WHITE
	jr print_move_start

print_move_b::
	call is_checked_w
	ld L, #PLAYER_BLACK

print_move_start:
	push AF

	; 萔\
	ld A, L
	push HL
	call print_turn
	push DE
	ld A, #9
	call print_spc
	pop DE
	pop HL

	; ړ̋
	ld A, #PIECE_PAWN
	or L
	inc OFF_PRO(IX)
	dec OFF_PRO(IX)
	jr NZ, print_move_pro
	push HL
	ld L, OFF_POS_TO(IX)
	ld H, #BOARD_H
	ld A, (HL)
	pop HL
print_move_pro:
	call get_symbol
	call putpat

	; ړ
	ld A, OFF_POS_FROM(IX)
	call print_pos

	; -
	ld A, #"-"
	call putchr

	; ?
	ld A, OFF_CAP(IX)
	or A
	jr Z, print_move_nocap

	; X
	push AF
	dec E
	ld A, #0xf0
	call putchr
	pop AF

	; 
	call get_symbol
	call putpat
print_move_nocap:

	; ړ
	ld A, OFF_POS_TO(IX)
	call print_pos

	; i?
	ld A, OFF_PRO(IX)
	or A
	jr Z, print_move_nopro

	; =
	push AF
	ld A, #"="
	call putchr
	pop AF

	; i
	call get_symbol
	call putpat
print_move_nopro:

	ld A, E
	ld (#pos_check), A

	pop AF

	; `FbN?
	ld A, #"+"
	ret Z
	jp putchr

;
; `FbNCĝƂ#\
;
; 
; DE:\ʒu
; Z:`FbNCgłȂ, NZ:`FbNCg
;
; o
; AF,HL:j
; DE:̈ʒu
;
print_mate::
	ld A, (#pos_check)
	ld E, A
	ld A, #"#"
	jr NZ, print_mate_skip
	ld A, #" "
print_mate_skip:
	inc E
	dec E
	ret Z
	jp putchr

pos_check::
	.db #0

;
; 萔\
;
; 
; A:
; DE:\ʒu
;
; o
; DE:̕\ʒu
; AF:j
;
print_turn::
	rlca
	jr C, print_turn_none

	ld A, (#turn)
	rrca
	and #0x7f
	inc A
	call print_num
	ld A, #"."
	jp putchr

print_turn_none:
	call msgpos
	ld A, #3
	jp print_spc

;
; vC[̋̑I𓾂
;
; 
; A:vC[
;
; o
; A:I
; Cy:I, NC:LZ
; BC,DE,HL:j
;
input_piece::
	ld B, #0
	ld C, A

	; vvg\
	ld HL, #input_piece_msg_b
	rlca
	jr C, input_piece_skip
	ld HL, #input_piece_msg_w
input_piece_skip:
	call msgpos
	inc E
	inc E
	inc E
	call print_str

input_piece_loop:
	; ͂𓾂
	call msgpos
	ld A, B
	add A
	add #5
	add E
	ld E, A
	call putcur
	call getkey
	call putcur
	cp #KEY_LEFT
	jr Z, input_piece_left
	cp #KEY_RIGHT
	jr Z, input_piece_right
	cp #KEY_CAN
	jr Z, input_piece_can
	cp #KEY_QUEEN
	jr Z, input_piece_queen
	cp #KEY_ROOK
	jr Z, input_piece_rook
	cp #KEY_BISHOP
	jr Z, input_piece_bishop
	cp #KEY_KNIGHT
	jr Z, input_piece_knight
	cp #KEY_OK
	jr Z, input_piece_sel
	jr input_piece_loop

; 
input_piece_left:
	dec B
	jp P, input_piece_loop
	ld B, #3
	jr input_piece_loop

; E
input_piece_right:
	inc B
	ld A, B
	cp #4
	jr NZ, input_piece_loop
	ld B, #0
	jr input_piece_loop

; LZ
input_piece_can:
	or A
	jr input_piece_last

; NB[
input_piece_queen:
	ld B, #0
	jr input_piece_sel

; [N
input_piece_rook:
	ld B, #1
	jr input_piece_sel

; rVbv
input_piece_bishop:
	ld B, #2
	jr input_piece_sel

; iCg
input_piece_knight:
	ld B, #3

; 
input_piece_sel:
	ld A, B
	add #PIECE_QUEEN
	or C
	scf

input_piece_last:
	; vvg
	push AF
	ld A, #11
	ld E, #8
	call print_spc
	pop AF
	ret

; ̃vvgbZ[W
input_piece_msg_w:
	.db 0xa0 + CHR_WPAWN
	.db #"="
	.db 0xa0 + CHR_WQUEEN
	.db #" "
	.db 0xa0 + CHR_WROOK
	.db #" "
	.db 0xa0 + CHR_WBISHOP
	.db #" "
	.db 0xa0 + CHR_WKNIGHT
	.db 0

; ̃vvgbZ[W
input_piece_msg_b:
	.db 0xa0 + CHR_BPAWN
	.db #"="
	.db 0xa0 + CHR_BQUEEN
	.db #" "
	.db 0xa0 + CHR_BROOK
	.db #" "
	.db 0xa0 + CHR_BBISHOP
	.db #" "
	.db 0xa0 + CHR_BKNIGHT
	.db 0

;
; ͂/̑I𓾂
;
; 
; HL:vvgbZ[W
;
; o
; Cy:͂I, NC:I
; A,BC,DE,HL:j
;
input_yn::
	call msgpos
	push DE
	call print_str

	ld HL, #msg_yn
	push DE
	call print_str
	pop DE
	ld C, #0

input_yn_loop:
	push DE
	ld A, C
	add A
	add E
	ld E, A
	call putcur
	call getkey
	call putcur
	pop DE

	cp #KEY_OK
	jr Z, input_yn_ok
	cp #KEY_YES
	jr Z, input_yn_yes
	cp #KEY_NO
	jr Z, input_yn_no

input_yn_change:
	inc C
	ld A, C
	and #0x01
	ld C, A
	jr input_yn_loop

input_yn_yes:
	ld C, #1
	jr input_yn_ok
input_yn_no:
	ld C, #0
input_yn_ok:
	pop DE
	ld A, #12
	call print_spc

	ld A, C
	rrca
	ret

;
; I𓾂
;
; 
; B:EL[őIľ
; C:㉺L[őIľ
; DE:EL[őIl̃AhX
; HL:㉺L[őIl̃AhX
;
; o
; AF,BC,DE,HL:j
;
select_item::
select_item_loop:
	call getkey
	cp #KEY_LEFT
	jr Z, select_item_prev
	cp #KEY_RIGHT
	jr Z, select_item_next
	cp #KEY_DOWN
	jr Z, select_item_down
	cp #KEY_UP
	jr Z, select_item_up
	ret

select_item_prev:
	ld A, (DE)
	dec A
	ld (DE), A
	jp P, select_item_last
	ld A, B
	dec A
	ld (DE), A
	jr select_item_last

select_item_next:
	ld A, (DE)
	inc A
	ld (DE), A
	cp B
	jr C, select_item_last
	xor A
	ld (DE), A
	jr select_item_last

select_item_down:
	dec (HL)
	jp P, select_item_last
	ld (HL), C
	dec (HL)
	jr select_item_last

select_item_up:
	inc (HL)
	ld A, (HL)
	cp C
	jr C, select_item_last
	ld (HL), #0
select_item_last:
	xor A
	ret

;
; bZ[W̕\ʒu𓾂
;
; 
; Ȃ
;
; o
; DE:bZ[W̕\ʒu
;
msgpos::
	push AF
	ld A, (#width)
	add #3
	ld E, A
	ld D, #5
	pop AF
	ret

;
; Ղ̏Ԃ\
;
; 
; Ȃ
;
; o
; AF,BC,DE,HL:j
;
disp_game::
.if TEST
.if 0
	; ̗\(eXg)
	ld DE, #0x0508
	ld HL, #ctrl_w + POS_A1
	call disp_ctrl
	ld DE, #0x0408
	ld HL, #ctrl_w + POS_A2
	call disp_ctrl
	ld DE, #0x0308
	ld HL, #ctrl_w + POS_A3
	call disp_ctrl
	ld DE, #0x0208
	ld HL, #ctrl_w + POS_A4
	call disp_ctrl
	ld DE, #0x0108
	ld HL, #ctrl_w + POS_A5
	call disp_ctrl
	ld DE, #0x0008
	ld HL, #ctrl_w + POS_A6
	call disp_ctrl
.endif

	; ̕]l\(eXg)
	ld A, (#w_eval_h)
	ld DE, #0x0514
	call print_num
	ld A, (#w_eval_l)
	ld DE, #0x0516
	call print_num

.if 0
	; ̗\(eXg)
	ld DE, #0x050e
	ld HL, #ctrl_b + POS_A1
	call disp_ctrl
	ld DE, #0x040e
	ld HL, #ctrl_b + POS_A2
	call disp_ctrl
	ld DE, #0x030e
	ld HL, #ctrl_b + POS_A3
	call disp_ctrl
	ld DE, #0x020e
	ld HL, #ctrl_b + POS_A4
	call disp_ctrl
	ld DE, #0x010e
	ld HL, #ctrl_b + POS_A5
	call disp_ctrl
	ld DE, #0x000e
	ld HL, #ctrl_b + POS_A6
	call disp_ctrl
.endif

	; ̕]l\(eXg)
	ld A, (#b_eval_h)
	ld DE, #0x0014
	call print_num
	ld A, (#b_eval_l)
	ld DE, #0x0016
	call print_num
.endif

.if 0
	ld A, #CHR_LEFT_1
	ld DE, #0x0500
	call putpat
	ld A, #CHR_LEFT_2
	ld DE, #0x0400
	call putpat
	ld A, #CHR_LEFT_3
	ld DE, #0x0300
	call putpat
	ld A, #CHR_LEFT_4
	ld DE, #0x0200
	call putpat
	ld A, #CHR_LEFT_5
	ld DE, #0x0100
	call putpat
	ld A, #CHR_LEFT_6
	ld DE, #0x0000
	call putpat
	ld A, #CHR_RIGHT_1
	ld DE, #0x0506
	call putpat
	ld A, #CHR_RIGHT_2
	ld DE, #0x0406
	call putpat
	ld A, #CHR_RIGHT_3
	ld DE, #0x0306
	call putpat
	ld A, #CHR_RIGHT_4
	ld DE, #0x0206
	call putpat
	ld A, #CHR_RIGHT_5
	ld DE, #0x0106
	call putpat
	ld A, #CHR_RIGHT_6
	ld DE, #0x0006
	call putpat
.endif

	; Rs[^̃x\
	ld DE, #0x0015
	ld HL, #msg_lv
	call print_str

	ld HL, #w_lv
	ld A, (HL)
	or A
	jr NZ, disp_game_skip
	inc H
	ld A, (HL)
disp_game_skip:
	add #"0" - 1
	call putchr

	; nf邩?
	ld DE, #0x0116
	ld A, (#handi)
	or A
	jr Z, disp_game_nohandi

	; nf\
	push AF
	ld A, #0xf0
	call putchr
	pop AF
	call get_symbol
	call putpat
	jr disp_game_handi_last
disp_game_nohandi:

	; nfȂ
	ld A, #3
	call print_spc
disp_game_handi_last:

	; Ղ̏Ԃ\
	ld HL, #board0 + 1
	call disp_rank
	call disp_rank
	call disp_rank
	call disp_rank
	call disp_rank
	call disp_rank
	call disp_rank

;
; Ղ̏Ԃ1s\ (disp_gamẻ)
;
; 
; HL:Տ̈ʒu
;
; o
; AF,BC,HL:j
;
disp_rank:
	push HL

	; sԍ𓾂
	ld A, L
	call to_xy
	ld A, D
	push AF

	; s̕\ʒu𓾂
	push AF
	ld A, L
	call to_scr
	pop AF
	push DE
	ld E, #0
	dec A
	dec A

	; ̍sԍ\邩?
	push HL
	ld HL, #height
	cp (HL)
	ld L, #CHR_LEFT_0
	jr NC, disp_rank_left_none

	; ̍sԍ\
	add #CHR_LEFT_1
	ld L, A
disp_rank_left_none:
	ld A, L
	call putpat
	pop HL

	; (\)𓾂
	ld A, (#width)
	ld B, A

disp_rank_loop:
	; 邩?
	ld A, (HL)
	cp #WALL
	jr Z, disp_file
	call get_symbol
	or A
	jr NZ, disp_rank_putpat

	; Ȃ
	ld A, L
	call to_xy
	ld A, D
	xor E
	and #0x01
	ld A, #CHR_NONE
	jp Z, disp_rank_putpat
	ld A, #CHR_NONE2

disp_rank_putpat:
	; p^[\
	push AF
	ld A, L
	call to_scr
	pop AF
	call putpat

disp_rank_skip:
	; ̈ʒu
	inc L
	djnz disp_rank_loop

	; s̕\ʒu𓾂
	pop DE
	ld A, (#width)
	ld E, A
	inc E
	pop AF
	dec A
	dec A

	; E̍sԍ\邩?
	push HL
	ld HL, #height
	cp (HL)
	ld L, #CHR_RIGHT_0
	jr NC, disp_rank_right_none

	; E̍sԍ\
	add #CHR_RIGHT_1
	ld L, A
disp_rank_right_none:
	ld A, L
	call putpat
	pop HL

	; ̔Տ̈ʒu𓾂
	pop HL
	ld A, L
	add #PITCH
	ld L, A
	ret

disp_file:
	; s\
	ld A, L
	call to_xy
	ld A, E
	add #CHR_A - 1
	push AF
	ld A, L
	call to_scr
	pop AF
	call putpat
	jr disp_rank_skip

;
; Տ̈ʒuʏ̈ʒu𓾂
;
; 
; A:Տ̈ʒu
;
; o
; DE:ʏ̈ʒu
;
to_scr::
	call to_xy
	dec D

	ld A, (#b_depth)
	or A
	jr Z, to_scr_b

to_scr_w:
	ld A, (#height)
	sub D
	ld D, A
	ret

to_scr_b:
	ld A, (#width)
	sub E
	ld E, A
	inc E
	dec D
	ret

;
; ̃p^[ԍ𓾂
;
; 
; A:
;
; o
; A:p^[ԍ
; F:j
;
get_symbol::
	or A
	jr Z, get_symbol_none
	cp #WALL
	jr Z, get_symbol_none
	rlca
	jr C, get_symbol_black
	rlca
	jr C, get_symbol_white

get_symbol_none:
	xor A
	ret

get_symbol_black:
	srl A
	add #CHR_BKING - 1
	ret

get_symbol_white:
	srl A
	rrca
	add #CHR_WKING - 1
	ret

;
; Copyright 2017 maruhiro
; All rights reserved. 
;
; Redistribution and use in source and binary forms, 
; with or without modification, are permitted provided that 
; the following conditions are met: 
;
;  1. Redistributions of source code must retain the above copyright notice, 
;     this list of conditions and the following disclaimer. 
;
;  2. Redistributions in binary form must reproduce the above copyright notice, 
;     this list of conditions and the following disclaimer in the documentation 
;     and/or other materials provided with the distribution. 
;
; THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, 
; INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND 
; FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL 
; THE REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
; SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
; PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; 
; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
; WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR 
; OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF 
; ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
;

; eof
